/*ֲļ*/
#include "port.h"
#include "COM3RS485.h"	
#include "USART2.h"	
#include "sys.h"	
/* ----------------------- Modbus includes ----------------------------------*/
#include "mb.h"
#include "mbport.h"
/* ----------------------- Start implementation -----------------------------*/
/*շʹ*/
void vMBPortSerialEnable( BOOL xRxEnable, BOOL xTxEnable )
{
	if(TRUE==xRxEnable)//ʹ
	{
        RS485_TX_EN=0;//رշ
		USART_ITConfig(USART2, USART_IT_RXNE, ENABLE);
	}
	else
	{
        RS485_TX_EN=1;//򿪷
		USART_ITConfig(USART2, USART_IT_RXNE, DISABLE);	
	}

	if(TRUE==xTxEnable)
	{
        RS485_TX_EN=1;//򿪷
		USART_ITConfig(USART2, USART_IT_TXE, ENABLE);
	}
	else
	{
       RS485_TX_EN=0;//رշ
	   USART_ITConfig(USART2, USART_IT_TXE, DISABLE);
	}
}

/*رմ*/
void vMBPortClose( void )
{
	USART_ITConfig(USART2, USART_IT_TXE|USART_IT_RXNE, DISABLE);
	USART_Cmd(USART2, DISABLE);
}

/*ڳʼ*/
BOOL xMBPortSerialInit( UCHAR ucPORT, ULONG ulBaudRate, UCHAR ucDataBits, eMBParity eParity )
{
	RS485_Init(ucPORT,ulBaudRate,ucDataBits);
	return TRUE;
}

/*ڷһ*/
BOOL xMBPortSerialPutByte( CHAR ucByte )
{
	USART_SendData(USART2, ucByte);	
	return TRUE;
}

/*ȡ*/
BOOL
xMBPortSerialGetByte( CHAR * pucByte )
{
	*pucByte = USART_ReceiveData(USART2);
	return TRUE;
}


/*жϷе*/
/* 
 * Create an interrupt handler for the transmit buffer empty interrupt
 * (or an equivalent) for your target processor. This function should then
 * call pxMBFrameCBTransmitterEmpty( ) which tells the protocol stack that
 * a new character can be sent. The protocol stack will then call 
 * xMBPortSerialPutByte( ) to send the character.
 */

//ָ룬ָ뷢жϺʵеĺ
void prvvUARTTxReadyISR(void)
{
    pxMBFrameCBTransmitterEmpty();/*pxMBFrameCBTransmitterEmptyΪָ룬յxMBRTUTransmitFSM()*/
}

/* 
 * Create an interrupt handler for the receive interrupt for your target
 * processor. This function should then call pxMBFrameCBByteReceived( ). The
 * protocol stack will then call xMBPortSerialGetByte( ) to retrieve the
 * character.
 */
//ָ룬ָжϺʵеĺ
void prvvUARTRxISR(void)
{
    pxMBFrameCBByteReceived();
}
