#include "COM3RS485.h"	
#include "USART2.h"	
#include "sys.h"		    
#include "delay.h"		

unsigned char RS485_RX_BUF[2048];
unsigned int RS485_RX_CNT=0;
extern unsigned int USART2_RX_CNT;
extern unsigned char USART2_RX_BUF[2048];

void RS485_Init(UCHAR ucPORT, ULONG ulBaudRate, UCHAR ucDataBits)
{  
	GPIO_InitTypeDef GPIO_InitStructure; 
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOG, ENABLE);
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_9;
 	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
 	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
 	GPIO_Init(GPIOG, &GPIO_InitStructure);
    
	(void)ucPORT;
	(void)ucDataBits;
//	(void)eParity;   
    
	USART2_Init(ulBaudRate);//ʹܴ2
    
	RS485_TX_EN=0;//رշ
}

void RS485_Send_Data(unsigned char *buf,unsigned char len)
{
	unsigned char t;
	RS485_TX_EN=1;
	for(t=0;t<len;t++)
	{
		while(USART_GetFlagStatus(USART2, USART_FLAG_TC) == RESET);	  
		USART_SendData(USART2,buf[t]);
	}
	while(USART_GetFlagStatus(USART2, USART_FLAG_TC) == RESET);	
	
	RS485_RX_CNT=0;
	RS485_TX_EN=0;
}

void RS485_Receive_Data(unsigned char *buf)//,unsigned char *len)
{
	unsigned char rxlen=RS485_RX_CNT;
	unsigned char i=0;
// 	*len=0;	
	delay_ms(10);
	if(rxlen==USART2_RX_CNT&&rxlen)
	{
		for(i=0;i<rxlen;i++)
		{
			buf[i]=USART2_RX_BUF[i];	
		}		
// 		*len=RS485_RX_CNT;
		USART2_RX_CNT=0;
	}
}


