#include "USART2.h"	  	
#include "sys.h"
#include "stm32f10x.h"			

/* ----------------------- Modbus includes ----------------------------------*/
#include "mb.h"
#include "mbport.h"
#include "port.h"

unsigned char USART2_RX_BUF[2048];//ýֽ  255

unsigned int USART2_RX_CNT=0;//

void USART2_Init(u32 bound)
{
    GPIO_InitTypeDef GPIO_InitStructure;
	USART_InitTypeDef USART_InitStructure;
	NVIC_InitTypeDef NVIC_InitStructure;
    
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA, ENABLE);	//GPIOAʱ
 	RCC_APB1PeriphClockCmd(RCC_APB1Periph_USART2,ENABLE);//ʹUSART2ʱ
	USART_DeInit(USART2);  //λ1
	//USART2_TX PA.2 
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_2;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;//
    GPIO_Init(GPIOA, &GPIO_InitStructure);
    //USART2_RX PA.3
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_3;    
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;//
    GPIO_Init(GPIOA, &GPIO_InitStructure);
    
    RCC_APB1PeriphResetCmd(RCC_APB1Periph_USART2,ENABLE);//λ2
	RCC_APB1PeriphResetCmd(RCC_APB1Periph_USART2,DISABLE);//ֹͣλ

   //Usart2 NVIC 
    NVIC_InitStructure.NVIC_IRQChannel = USART2_IRQn;
	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;//ռȼ0
	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 1;		//ȼ0
	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;			//IRQͨʹ
	NVIC_Init(&NVIC_InitStructure);	//ָĲʼVICĴ
  
   //USART ʼ
	USART_InitStructure.USART_BaudRate = bound; //
	USART_InitStructure.USART_WordLength = USART_WordLength_8b; //ֳΪ8λݸʽ
	USART_InitStructure.USART_StopBits = USART_StopBits_1; //һֹͣλ
	USART_InitStructure.USART_Parity = USART_Parity_No; //żУλ
	USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None; //Ӳ
	USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;	//շģʽ

    USART_Init(USART2, &USART_InitStructure); //ʼ
	
    USART_ITConfig(USART2, USART_IT_RXNE, ENABLE); //ж

    USART_Cmd(USART2, ENABLE); //ʹܴ  
}

void USART2_IRQHandler(void) //2жϷ
{
    if (USART_GetITStatus(USART2, USART_IT_RXNE) == SET)  //ж
    {
        prvvUARTRxISR();
        USART_ClearITPendingBit(USART2, USART_IT_RXNE);
    }
         
    if (USART_GetITStatus(USART2, USART_IT_TC) == SET)  //ж
    {
        prvvUARTTxReadyISR();
        USART_ClearITPendingBit(USART2, USART_IT_TXE);
        //USART_ClearITPendingBit(USART2, USART_IT_TC);
    } 
} 

